### small script to download data from yahoo finance 

# install.packages("tidyquant")
require(tidyquant)


options("getSymbols.warning4.0"=FALSE)
options("getSymbols.yahoo.warning"=FALSE)


ticker = ticker<-c("ABT","ABBV","AMGN","BAX","BIIB","BMY","GILD","JNJ","LLY","MDT","MRK","PFE","UNH",
                   "BAC","BK","C","COF","GS","JPM","MET","MS","RF","USB","WFC",
                   "APA","BKR","COP","CVX","DVN","HAL","NOV","OXY","SLB","WMB","XOM",
                   "CAT","EMR","FDX","HON","MMM","NSC","UNP","UPS")
 

# download from yahoo
for(ii in 1:length(ticker)){
  getSymbols(ticker[ii], from = "2014-01-01",
             to = "2020-01-01",warnings = FALSE,
             auto.assign = TRUE)
}

 
# get returns of adjusted prices
returns = list()
for(j in 1:length(ticker)){
  x = fortify.zoo(get(ticker[j])[,6])
  colnames(x)[1] = "Date"
  m = dim(x)[1]
  x[,2] = c(NA,100*log(x[2:m,2]/x[1:(m-1),2]))
  # x[,2] = c(NA,100*(x[2:m,2]-x[1:(m-1),2])/x[2:m,2])
  returns[[ticker[j]]] = x
}


# merge
mydata = Reduce(function(x, y) merge(x, y, by = "Date"), returns)
return = na.omit(mydata)

colnames(return)[2:ncol(return)] = ticker
head(return)

exogen.name = "gold";
mypath = "C:/Users/alexa/OneDrive/COP/JoE_revision/empirics_new/"
mypath_exog = paste0(paste0(mypath,"exogenous_covariate",sep="/"),exogen.name,".csv")

exogen = read.table(mypath_exog,
                    header = TRUE,
                    sep = ",", 
                    dec = ".",
                    stringsAsFactors = FALSE)

colnames(exogen) = c("Date",exogen.name)
exogen.clean     = exogen[!exogen[,2]==".",]
exogen.clean$Date= as.Date(exogen.clean$Date, tryFormat ="%Y-%m-%d")
exogen.clean[,2] = as.numeric(exogen.clean[,2])
m = dim(exogen.clean)[1]
exogen.clean$goldreturn = c(NA,100*log(exogen.clean[2:m,2]/exogen.clean[1:(m-1),2])) 
 
 
data = merge(return,exogen.clean[,c(1,3)],by="Date")
head(data)

sum(data[,ncol(data)]==0)
selectData = data[!data[,ncol(data)]==0,]
head(selectData)

setwd(mypath)
getwd()
write.csv(selectData,"returns_all4.csv")

 