function [x,y] = ini_grid(theta_ini0,data,Weight,q,Z,model,blks,LB,UB,T,N,S1,rhoS,rng_type,ini,seed)
% if ini = 1 grid search over nu (dof parameter) else returns provided starting value theta_ini0
% S1: number of simulation draws for grid search
if strcmp(ini,'true')
    st = size(LB,2); lh_st =   LB(2:end); uh_st =   UB(2:end);
    grid =     0.05:0.05:.4;
    startval = theta_ini0(2:end);
    theta_ini_temp = nan(st-1,length(grid)); obj_temp = nan(length(grid),1);
 
fun0 = @(y) fminsearchbnd(@(x) objfunc(x, y, data,Weight,q,Z,model,...
                                                   seed,blks,rng_type,rhoS,'true'),startval,lh_st,uh_st); 
% opts = optimoptions('surrogateopt','UseParallel',false,'PlotFcn',[],'display','off');     
% fun0 = @(y) surrogateopt(@(x) objfunc_SMM_blk_pre(x, y, data,Weight,q,Z,Zblock,eps_dist,seed,blks,rng_type,rhoS),lh_1st,uh_1st, opts); 

    for ss = 1:length(grid)
        others = [T S1 N  grid(ss)];
        [theta_temp, objval_temp,~,~]=   fun0(others);%
        theta_ini_temp(:,ss) = theta_temp;
        obj_temp(ss) = objval_temp;
    end
    
    inx0 = min(unique(find(obj_temp==min(obj_temp))));   
    x = [grid(inx0) theta_ini_temp(:,inx0)'];
    y = obj_temp(inx0);
    
elseif strcmp(ini,'false')
    x = theta_ini0; y = nan;
end
end